#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <malloc.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>

#define FALSE	0
#define TRUE	1
// #define DEBUG 1
// #define MOREDEBUG 1
// #define DEBUGHASH 1
// #define DEBUGINI 1
// zatim neni dodelan preskok normalizace
// je potreba inicializovat jeste jednu pomocnou tabulku.

// int figury[16];			// tabulka volnych kamenu
	// TRUE ... tento kamen je uz umisten

int pole[16];                                   // aktualni hraci pole
	// bity 0-3 ... kladne rysy
	// bity 4-7 ... zaporne rysy
	// prazdne policko ... 0
int obsazeni=0;                 // maska obsazenych poli
long int startTime,currTime,addTime=0;

#define hashMez 0x1000000
#define MAXHASUJDO 10
int hasujDo=MAXHASUJDO,normDo=MAXHASUJDO,preHasujDo=MAXHASUJDO;

union osmbytu
 {unsigned char c[8];           // normalizovana pakovana pozice
  unsigned u[2];
 } norm;

// nasleduje kodovani vysledku
#define Nevim         0x00    // dosud nemam spocitano
#define VyhralPrvni   0x01    // ten, kdo je na tahu (bude vybirat figurku)
#define Remiza        0x02
#define VyhralDruhy   0x03    // ten, kdo neni na tahu
#define MaskaVysledku 0x03    // maska vysledkovych bitu
#define Doplnek       0x04    // pro vypocet negace vysledku

#define MaskA 0x00 // transformace urcena jednoznacne
#define MaskB 0x20 // shodny kod (nejvys 2 figury)
#define MaskC 0x40 // symetrie teto pozice v male hash
#define MaskD 0x60 // symetrie vysledne pozice v male hash
#define SHIFT 15   // cim je posunuto cislo pozice daneho poctu figur
// pocty jsou 1 2 a 1c 54 a8 132 19a 1dc 19a 132 a8 54 1c a 2 1
// proto staci 17 bitu.

#define TransfAB  0x03
 // maska pro kombinace nasledujicich dvou transformaci
 // 0<->5,1<->4,2<->7,3<->6,8<->13,9<->12,10<->15,11<->14.
 // 0,1<->2,3,4<->8,5<->10,6<->9,7<->11,12,13<->14,15.
#define TransfC  0x04 // maska pro
  // 0,1<->4,2<->8,3<->12,5,6<->9,7<->13,10,11<->14,15.
#define TransfD  0x18 // maska pro otaceni
  // 0->12->15->3->0,1->8->14->7->1,2->4->13->11->2,5->9->10->6->5.

#define TransfVecMask   0x17 // hranice pro aritmetiku transformaci

int transfPlus (int a,int b ) // nejdriv a pak b.
{int h=(a^b)&TransfVecMask;
 int s=(a&~TransfVecMask)+(b&~TransfVecMask);
 s^=h;
#ifdef DEBUG
 printf("%u o %u = ",a,b);
#endif
 a++;s^=(a&b&2)<<3;
  // protoze ABAB=D^2,C,D komutuje se vsim a A^2=B^2=C^2=D^4=1
#ifdef DEBUG
 printf("%u\n",s);
#endif
 return s;
}

int transfInv(int a)
{int h=a&3==2?0x10:0;h^=(a&8)<<1;return a^h;
}

char cisloPerm[4][4][4][4];
void initCisloPerm ()
{int i,ii,iii,n,cetnost[4],perm[4],pomperm[4];
  for (i=0;i<256;i++)
   {
    for (ii=0;ii<4;ii++) perm[ii]=(i>>(ii<<1))&3;
    for (ii=0;ii<4;ii++)
     cetnost[perm[ii]]=0;
    for (ii=0;ii<4;ii++)
     cetnost[perm[ii]]++;
    for (ii=0;ii<4;ii++)
     pomperm[ii]=perm[ii]+(--cetnost[perm[ii]]);
    for (ii=3;ii>0;) {n=0; ii--;
      for (iii=0;iii<ii;iii++)
        if (pomperm[iii]<pomperm[ii]) n++;
           pomperm[ii]-=n;
                     }
    cisloPerm[perm[0]][perm[1]][perm[2]][perm[3]]=pomperm[0]*6+pomperm[1]*2+pomperm[2];
   }
}

int permBit[24][16];                 // tabulka slouzici k rychlemu
        // prevodu figurek pro unifikaci
	// podle tohoto pole se bude sestavovat polozka hasovaci tabulky
        // klicem pristupu je lexikograficke poradi bitove permutace
        // vybiram abych lexikograficky minimalizoval hashovanou pozici
        // jak? To jeste musim vymyslet.
void initPermBit ()
{int i,j;
 for (i=0;i<24;i++) {int ii=i; int perm[4];
  perm[3]=0;
  for (j=3;j>0;) {j--;
    perm[j]=ii % (4-j);
    ii /= (4-j); }
    // z tech co mi zbydou kolikata
    // for (ii=0;ii<4;ii++) printf("%d",perm[ii]);  printf("-");
  for (j=4;j>0;) {j--;
	for (ii=j;ii>0;) {ii--;
		if (perm[ii]<=perm[j]) perm[j]++;
	                 }
                 }
    // for (ii=0;ii<4;ii++) printf("%d",perm[ii]);  printf(" ");
    // vysledna permutace (kam se ma i-ty bit premistit)
  if ( cisloPerm[perm[0]][perm[1]][perm[2]][perm[3]]!=i )
    printf("chybne inicializovane permutace(%d)\n",i);
  for (j=0;j<16;j++) 
	  permBit[i][j]=((j&1)<<perm[0])|
		       (((j>>1)&1)<<perm[1])|
               (((j>>2)&1)<<perm[2])|
			   (((j>>3)&1)<<perm[3]);                    
                    }
}

char symetrie[32][16]; // permutace poli pro jednotlive transformace
char symPoradi[32][16]; // symPoradi je poradi poli pro jednotlive symetrie
char *poradiPoli=symPoradi[0];  // poradiPoli je totozne s poradim figurek
char poliPoradi[16];  // invers k poradiPoli
void initSymetrie()
{char i,j,ab,c,d;
 poradiPoli[0]=0;poradiPoli[1]=15;poradiPoli[2]=3;poradiPoli[3]=12;
 poradiPoli[4]=5;poradiPoli[5]=10;poradiPoli[6]=6;poradiPoli[7]=9;
 poradiPoli[8]=1;poradiPoli[9]=4;poradiPoli[10]=2;poradiPoli[11]=8;
 poradiPoli[12]=7;poradiPoli[13]=13;poradiPoli[14]=11;poradiPoli[15]=14;
 for(i=0;i<16;i++){poliPoradi[poradiPoli[i]]=i;}
 // identita
 for(i=0;i<16;i++){symetrie[0][i]=i;}
 // A
 for(i=0;i<16;i++){symetrie[1][i]=i^5;}
 // B
 for(i=0,c=cisloPerm[1][0][3][2];i<16;i++){symetrie[3][i]=permBit[c][i];}
 // C
 for(i=0,c=cisloPerm[2][3][0][1];i<16;i++){symetrie[4][i]=permBit[c][i];}
 // D
 symetrie[8][ 0]=12;symetrie[8][12]=15;symetrie[8][15]= 3;symetrie[8][ 3]= 0;
 symetrie[8][ 1]= 8;symetrie[8][ 8]=14;symetrie[8][14]= 7;symetrie[8][ 7]= 1;
 symetrie[8][ 2]= 4;symetrie[8][ 4]=13;symetrie[8][13]=11;symetrie[8][11]= 2;
 symetrie[8][ 5]= 9;symetrie[8][ 9]=10;symetrie[8][10]= 6;symetrie[8][ 6]= 5;
 // DD, DDD
 for(i=0;i<16;i++)
 {symetrie[16][i]=symetrie[8][symetrie[8][i]];
  symetrie[24][i]=symetrie[8][symetrie[16][i]];
 }
 // BA
 for(i=0;i<16;i++)
 {symetrie[2][i]=symetrie[1][symetrie[3][i]];}
 for(j=5;j<32;j++)
  {int ab = j&TransfAB; int c = j&TransfC; int d = j&TransfD;
   for(i=0;i<16;i++)
    {symetrie[j][i]=symetrie[ab][symetrie[c][symetrie[d][i]]];}
  }
#ifdef DEBUGINI
 for(j=0;j<32;j++)
  {printf("\n %2x:",j);
   for(i=0;i<0x10;i++) printf("%x",symetrie[j][i]);
   printf(" %2x:",++j);
   for(i=0;i<0x10;i++) printf("%x",symetrie[j][i]);
   printf(" %2x:",++j);
   for(i=0;i<0x10;i++) printf("%x",symetrie[j][i]);
   printf(" %2x:",++j);
   for(i=0;i<0x10;i++) printf("%x",symetrie[j][i]);
  }
 printf("\n");
#endif
 for(j=1;j<32;j++) // symPoradi[0]=poradiPoli
  for(i=0;i<16;i++)
   symPoradi[j][i]=symetrie[j][poradiPoli[i]];
#ifdef DEBUGINI
 for(j=0;j<32;j++)
  {printf("\n %2x:",j);
   for(i=0;i<0x10;i++) printf("%x",symPoradi[j][i]);
   printf(" %2x:",++j);
   for(i=0;i<0x10;i++) printf("%x",symPoradi[j][i]);
   printf(" %2x:",++j);
   for(i=0;i<0x10;i++) printf("%x",symPoradi[j][i]);
   printf(" %2x:",++j);
   for(i=0;i<0x10;i++) printf("%x",symPoradi[j][i]);
  }
 printf("\n");
#endif
}

char *poradiFigurek=poradiPoli;
char *figurekPoradi=poliPoradi;

int figNext[16],poleNext[16];  // 0x10 znamena null
int firstFig,firstPole;

void initNext()
{int i,p;
 for(p=firstPole=poradiPoli[i=0];i<15;)
  p=poleNext[p]=poradiPoli[++i];
 poleNext[p]=0x10;    // null (14 je posledni v poradi)
 for(p=firstFig=poradiFigurek[i=0];i<15;)
  p=figNext[p]=poradiFigurek[++i];
 figNext[p]=0x10;    // null (14 je posledni v poradi)
}

int hashvys[15][16];
  // hashvys[t][p]
  // vysledek nacteny z hashe v tahu t pro policko [p] (pokud je volne)

void initVys()
{int i,j;
 for(j=0;j<15;j++)  
// ve skutecnosti staci inicializovat pouze tam, kde se nehasuje
  for(i=0;i<16;i++)
   hashvys[j][i]=0;
}

unsigned normHash[15][16][2]; // loNorm,hiNorm
int orivys[15][16];
  // orivys[t][p] (puvodni vysledek v hashi (nezavisle na ID))

unsigned preHashNorm[257][2];
int preHashPoz[257];
int toPreHash[16];
 // slouzi k identifikaci symetrickych pozic
 // neni potreba provadet rekurzi pro symetrickou pozici podruhe.
 // ve skutecnosti to nijak neurychli vypocet, protoze vysledek bude 
 // jiz nalezen v hashi. 
 // Na druhou stranu to zlepsi statistiky prepisovani v hasi. 
 // Opticky to take vylepsi "pokrok" algoritmu, pokud budeme preskakovat
 // symetricke pozice krome te posledni.

void initPreHash()
{int i;
 for(i=0;i<257;) preHashPoz[i++]=0x10; // identifikuje prazdno
}

unsigned prob[4][4];
  // prob[orivys][newvys]/RAND_MAX je  pravdepodobnost prepisu
  // vysledku orivys vysledkem newvys
  // prepisovaci pravdepodobnosti pro strategii reseni kolizi.

void initProb()
{int i,j;
 for(i=0;i<4;i++)
  for(j=1;j<4;j++)
   prob[i][j]=RAND_MAX;
 prob[1][2]=RAND_MAX/10;
 prob[1][3]=RAND_MAX/1000;
 prob[2][3]=RAND_MAX/100;
 for(i=0;i<4;i++) prob[i][0]=0; // pro jistotu
}

int normTransf[0x10000];
unsigned *trMask[14];// pole masek nejednoznacnych pozic podle tahu (figurek-1) 
int initNormTransf()
{int h,hs,haddr,nhs,i,t,o,oo,transformace[32],pocettr,pocetpoli,
  novypocettr,mask,found,pocet[17],pocetMasek[17];
 unsigned u;
 hs=0;
 pocet[0]=pocet[1]=pocet[15]=pocet[16]=0;
 pocet[2]=0x2; // pozice s jednou a dvema figurami spojim, 
               // proto potrebuji cisly rozlisit
               // pocet predem zapocita pozice s vice symetriema
 trMask[0x02]=(unsigned *)malloc(4*(pocet[0x03]=0x12)); // 4==sizeof unsigned 
 trMask[0x03]=(unsigned *)malloc(4*(pocet[0x04]=0x2c));  
 trMask[0x04]=(unsigned *)malloc(4*(pocet[0x05]=0x3a));
 trMask[0x05]=(unsigned *)malloc(4*(pocet[0x06]=0x5e));
 trMask[0x06]=(unsigned *)malloc(4*(pocet[0x07]=0x62));
 trMask[0x07]=(unsigned *)malloc(4*(pocet[0x08]=0x7e));
 trMask[0x08]=(unsigned *)malloc(4*(pocet[0x09]=0x62));
 trMask[0x09]=(unsigned *)malloc(4*(pocet[0x0a]=0x5e));
 trMask[0x0a]=(unsigned *)malloc(4*(pocet[0x0b]=0x3a));
 trMask[0x0b]=(unsigned *)malloc(4*(pocet[0x0c]=0x2c));  
 trMask[0x0c]=(unsigned *)malloc(4*(pocet[0x0d]=0x12)); 
 trMask[0x0d]=(unsigned *)malloc(4*(pocet[0x0e]=0x08));
 for(i=0;i<17;i++) pocetMasek[i]=0;
 for(o=0;o<0x10000;o++)
  {pocetpoli=0;
   for(i=16,oo=o;i>0;oo>>=1) {pocetpoli+=pole[poradiPoli[--i]]=oo&1;}
   for(t=0;t<32;t++) transformace[t]=t; pocettr=32;
   for(i=0;i<16&pocettr>1;i++)
    {found=0;
     for(t=0;t<pocettr;t++)
      if ( pole[symPoradi[transformace[t]][i]] ) {found=1;break;}
     if ( found )
      { for(novypocettr=0;t<pocettr;t++)
         if ( pole[symPoradi[transformace[t]][i]] )
          {transformace[novypocettr++]=transformace[t];}
        pocettr=novypocettr;
      }
    }
   if ( pocettr == 1 )
    mask = MaskA;
   else if ( pocetpoli<3 )
    mask = MaskB;
   else if ( !transformace[0] )
    {mask = MaskC;
     for(u=t=0;t<pocettr;t++) {u|=1<<(transformace[t]);}
     t=pocetMasek[pocetpoli]++;
     if (pocetpoli<15) trMask[pocetpoli-1][t]=u;
     mask|=t<<SHIFT;
    }
   else mask = MaskD;
   if ( !transformace[0] && mask<MaskC )
         // mask nemuze byt MaskD a MaskA,MaskB<MaskC
    mask|=(pocet[pocetpoli]++)<<SHIFT;
   normTransf[o]=mask|transformace[0];
  }
#ifdef DEBUGINI
   for(i=0;i<17;i++) printf("%x/%x ",pocetMasek[i],pocet[i]);
   printf("\n");
#endif
}

//tah=pultah>>1; (posledni tah)
// sudy pultah vyber figury, tahyf[pultah>>1] 0 2 4 6 -> 0 1 2 3
// lichy pultah vyber pole.  tahyp[pultah>>1] 1 3 5 7 -> 0 1 2 3

int tahyp[16],tahyf[16],vyslp[16],vyslf[16],minvys[16];
                                    // zasobnik aktualnich tahu
                                    // (pozice,figura,mezivysledek)
int pultah,tah = 0;                        // posledni tah

struct stat{
 unsigned hasovani,trefy,zapisy,prepisy;
 unsigned trefylast,hasovanilast,trefynow,hasovaninow;
};

struct hashtype{
 char *id;
 char *vys;
 int idlen; // 3 az 7 nebo 0, ktera znamena neukladat id 
            //                    (nejedna se o hashovani)
 unsigned hashprime,highfact;
 struct stat s;
 } hase[MAXHASUJDO+1];  // indexovana tahem (ne poctem poli!)

unsigned quart[15];  // ma posunutou indexaci (tah-1)

char order(unsigned u)
{char o;
 u>>=12;
 for(o=0;u;o++){u>>=4;}
 return o&15;
}

void tiskniTahy ()
{char i,o;long int d,h,m,s;
 time(&currTime);
 s=currTime-startTime+addTime;
 m=s/60;s%=60;
 h=m/60;m%=60;
 d=h/24;h%=24;
 printf("---- %s ---- ubehlo %d dni, %d hodin, %d minut a %d sekund\n"
  ,4+ctime(&currTime),d,h,m,s);
 printf("quart          ");
 for(i=2;i<15;i++) o=order(quart[i]),printf("%01x%03x ",o,quart[i]>>(o<<2));
 printf("     ");
 for(i=1;i<=MAXHASUJDO;i++) o=order(hase[i].s.hasovani),
  printf("%01x%03x ",o,hase[i].s.hasovani>>(o<<2));
 printf("  hasovani\n     ");
 for(i=1;i<=MAXHASUJDO;i++) printf("%03u%%.",
  hase[i].s.hasovani?hase[i].s.trefy*1000/hase[i].s.hasovani:999);
 printf(" tref\n     ");
 for(i=1;i<=MAXHASUJDO;i++) printf("%03u%%.",
  hase[i].s.hasovanilast?hase[i].s.trefylast*1000/hase[i].s.hasovanilast:999);
 printf(" nyni\n     ");
 for(i=1;i<=MAXHASUJDO;i++) o=order(hase[i].s.zapisy),
  printf("%01x%03x ",o,hase[i].s.zapisy>>(o<<2));
 printf(" nove\n     ");
 for(i=1;i<=MAXHASUJDO;i++) o=order(hase[i].s.prepisy),
  printf("%01x%03x ",o,hase[i].s.prepisy>>(o<<2));
 printf(" pres\n");
 for (i=firstPole; i<0x10; i=poleNext[i]) printf("%x ",i);
 o=(vyslf[0]==Remiza?'=':'-');
 printf("%c%c ",o,o);
 for (i=firstFig;i<0x10;i=figNext[i]) printf("%x ",i);
 printf("\n");
 for (i = 0; (i<<1) < pultah; i++ )
  printf("[%x%c%x]",poliPoradi[tahyp[i]],
                    vyslp[i]==Remiza?'=':'-',tahyp[i]);
   // udava poradi pole, mezivysledek a pole.
 if ( pultah<31 ) printf("\n");
 printf("0}");
 for (i = 1; (i<<1) <= pultah; i++ )
  printf("{%x%c%x}",figurekPoradi[tahyf[i]],vyslf[i]==Remiza?'=':'-',tahyf[i]);
   // udava poradi figury, mezivysledek (nemuze byt Vyhra ani Nevim) a figuru.
 printf("\n");
}

void initStatNow(struct stat *s)
{s->trefylast=s->trefynow;
 s->hasovanilast=s->hasovaninow;
 s->trefynow=s->hasovaninow=0;
#ifdef DEBUG
 tiskniTahy();
#endif
}

void initQuart()
{int i;
 for(i=0;i<16;i++) quart[i]=0;
}

void initStat(struct stat *s)
{s->hasovani=s->trefy=s->zapisy=s->prepisy=0;
 initStatNow(s);initStatNow(s);
}

void Volba( int figura ) // figura je 8-bitova, ale staci dolni 4 bity
{// figury[figura&0x0f]=0;
 tahyf[++tah]=figura&0x0f;
 pultah++;
}

void DFSVolba( int *fig ) // *fig je 4-bitova
{Volba(*fig);
 *fig=figNext[*fig];
}

void Odvoleni()
{// figury[tahyf[tah--]]=1;
 tah--;
 pultah--;
}

void DFSOdvoleni( int *fig )
{*fig=tahyf[tah];Odvoleni();
}

void Polozeni( int figura, int policko ) // figura je 8-bitova
{ pole[policko] = figura;
  obsazeni|=0x8000>>poliPoradi[policko];
  tahyp[tah]=policko;pultah++;
}

void DFSPolozeni( int *policko ) // Polozi figuru a odebere ji ze seznamu
{int figura=tahyf[tah];figura|=((~figura)&0x0f)<<4;
 Polozeni(figura,*policko);
 *policko=poleNext[*policko];
}

void Zdvizeni( int policko)
{ pole[policko] = 0;
  obsazeni^=0x8000>>poliPoradi[policko];
  pultah--;
}

void DFSZdvizeni( int *policko ) // Vrati figuru z desky do seznamu
{ *policko=tahyp[tah];
  Zdvizeni( *policko );
}

void firstMove (int kam )  // kam je bud 0 nebo 1
{ for(int i=0;i<16;i++)
   {pole[i]=0; // figury[i]=1;
   }
  // figury[0]=0;
  tahyf[0]=pultah=tah=obsazeni=0;
  initNext();
  firstFig=figNext[0]; // DFSVolba(&firstFig);
  if (!kam)
    DFSPolozeni(&firstPole);
  else
    DFSPolozeni(&poleNext[8]);
}

int fig2[16]; // kodovani druhe figury pocet jednickovych bitu bez 1
              // pokud tvori souvisly usek nejvyznamejsich bitu.
              // jinak hodnota 4 indikujici chybu.

void initFig2 ()
{int i,o ;
 for (i=0;i<16;i++)
  {for (o=0;o<4;o++)
    if (!(i&(1<<(3-o)))) break;
   fig2[i]=o-1;
   if (o) // byla nejaka jednicka
    for (;o<4;o++)
     if (i&(1<<(3-o))) break;
   if (o!=4) fig2[i]=4;  
  }  
#ifdef DEBUGINI
 for (i=0;i<16;i++) printf("fig2[%i]=%i ",i,fig2[i]);
 printf("\n");
#endif
}

int fig2PermBit[16]; // pro rychlou normalizaci urceni premutace zajistujici
                     // sesypani jednickovych bitu doleva
void initFig2PermBit()
{int ii,p,pp,b[4],cetnost[2],permstart[4];
for(pp=p=0;p<16;pp=++p)
 {for(ii=0;ii<4;ii++)
   b[ii]=pp&1,pp>>=1;
  cetnost[0]=cetnost[1]=0;
  for(ii=0;ii<4;ii++)
   cetnost[b[ii]]++;
  for(ii=0;ii<4;ii++)
   if (b[ii]) permstart[ii]=4-cetnost[b[ii]];
   else permstart[ii]=0;
fig2PermBit[p]=cisloPerm[permstart[0]][permstart[1]]
                        [permstart[2]][permstart[3]];
 }
#ifdef DEBUGINI
 for(p=0;p<16;p++) printf("%i ",fig2PermBit[p]);
 printf("<- fig2PermBit\n");
#endif
}
    //ve druhe fazi normalizace je spocitana normalizovana adresa
unsigned hiNorm,loNorm;       //vyssi a nizsi cast normalizovane adresy.

void normalizuj () // vyplni norm podle aktualni pozice
{int h,i,op,p,tr,normtr,mez,posun;
 int trObsazeni,xorFig,permFig,transPoli,pozNum,trObsPoz[14],pocetPoli;
                              //hodnoty nastavene normalizaci.
 unsigned trmask=1,lexmax,u; // identita
 int transf[32],hashdepth,poctr,npoctr;
 char *pn,fx;
#ifdef DEBUG
 printf(">norm\n");
#endif
 if (normtr=(tr=normTransf[trObsazeni=obsazeni])&0x1f)
  {for (trObsazeni=pocetPoli=i=0;i<16;i++)
    if (pole[symPoradi[normtr][i]]) 
     {trObsazeni|=0x8000>>i;
      trObsPoz[pocetPoli++]=i;}
   tr=normTransf[trObsazeni];
  }
 else // trObsPoz,pocetPoli musi byt spocitano i v tomto pripade
  {for (pocetPoli=i=0;i<16;i++)
    if ( trObsazeni&(0x8000>>i) )
     trObsPoz[pocetPoli++]=i;
  }
 pozNum=(tr>>SHIFT)&0x1ff;
#ifdef DEBUG
 printf("norm1\n");
 if ( pocetPoli!=tah+1 ) printf("!Nesouhlasi tah+1(%i) a pocetPoli(%i)!\n",tah+1,pocetPoli);
 if (tr&0x1f) printf("!Co to je za blbost!\7\n");
#endif
 if (tah<=normDo) 
    //transPoli, xorFig a permFig je figurove normalizovano jen v male hloubce
  {if ( tr&0x60==MaskC )
    trmask=trMask[tah][pozNum];
#ifdef DEBUG
 printf("norm2\n");
 if (!trmask) printf("!Divne hashovani\n");
 if (!(trmask&1)) printf("!A co identita?");
#endif
   for( poctr=i=0; i<16; i++,trmask>>=1)
    if (trmask&1) transf[poctr++]=transfPlus(normtr,i);

        // nyni jsou v poli transf vsechny transformace, udrzujici normovane
        // rozestaveni figurek, nebo (v pripade <= 2) figurek jsou vsechny
        // transformace ekvivalentni, pak je tam jen normujici transformace.
        // Uvedene transformace bylo potreba slozit s transformaci prevadejicimi
        // puvodni pozici do normovane!

        // bude treba zvolit permFig ... cislo permutace rysu pro normalizaci

#ifdef DEBUG
printf("%c%u:",poctr>1?'!':' ',poctr);
for(i=0;i<poctr;i++)
 printf("%u,",transf[i]);
printf("norm3\n");
#endif
union {char c[2][4];
       unsigned u[2];
      } cetnost[32];

       // cetnost[32].c[2][4];
       // cetnost[t].c[b][p] cetnosti bitu b ktere mohou byt na
       //                    pozici p-teho bitu pri transformaci t.

 int figXor[32],
       // figxor[t] cim jsou xorovany figury pri transformaci t.
     permstart[32][4],
       // permstart[t][p] prvni pozice, na niz se muze vyskytnout
       //                  p-ty bit pri transforaci t
     permlen[32][4],
       // permlen[t][4]  delka intervalu, na nemz se muze vyskytnout
       //                  p-ty bit pri transforaci t
     b[32][4],
       // b[t][p]        p-ty bit aktualniho pole transformace t
     *ps,*pl,*pb,t,ii,
     cont=1; // bitova permutace a trasforace dosud nejsou urceny
   for(t=0;t<poctr;t++)
    {for(ps=permstart[tr=transf[t]],i=0;i<4;i++) {*ps++=0;}
     for(pl=permlen[tr],i=0;i<4;i++) {*pl++=3;}
     figXor[tr]=pole[symPoradi[tr][trObsPoz[0]]];
    }
   for(i=1;i<pocetPoli&&cont;i++)
    {op=trObsPoz[i];
     for(t=0;t<poctr;t++)
      {p=pole[symPoradi[tr=transf[t]][op]];
       cetnost[tr].u[0]=cetnost[tr].u[1]=0; 
       p^=figXor[tr];
#ifdef DEBUG
 printf("transformace %x,pole %x, figura %x:\n",tr,i,p);
#endif
       for (ii=0,pb=b[tr],ps=permstart[tr];ii<4;ii++)
        *pb++=p&1,p>>=1;
       for (ii=0,pb=b[tr],ps=permstart[tr];ii<4;ii++)
        cetnost[tr].c[*pb++][*ps++]++;
#ifdef DEBUG
 for(ii=0;ii<4;ii++) printf("b[%u][%u]=%u,pstart[%u][%u]=%u,plen[%u][%u]=%u,ctn[%u].c[0][%u]=%u,ctn[%u]i.c[1][%u]=%u\n",tr,ii,b[tr][ii],tr,ii,permstart[tr][ii],tr,ii,permlen[tr][ii],tr,ii,cetnost[tr].c[0][ii],tr,ii,cetnost[tr].c[1][ii]);
#endif
      }
     // cetnost[t].c[0][*]+cetnost[t].c[1][*] je shodne pro vsechny
     // pripustne trasformace t.
     // Vzhledem k big-endian je lexikograficky vetsi
     // vysledek ten vysledek, kde je u[1] vetsi.
     //
     for(npoctr=lexmax=t=0;t<poctr;t++)
      if ( (u=cetnost[tr=transf[t]].u[1])>lexmax )
       {lexmax=u;npoctr=0;transf[npoctr++]=tr;}
      else if ( u==lexmax )
       {transf[npoctr++]=tr;}
     poctr=npoctr;cont=poctr-1;
     for(t=0;t<poctr;t++)
      {tr=transf[t];
       for(ii=0,pb=b[tr],ps=permstart[tr],pl=permlen[tr];ii<4;ii++,ps++)
        {p=*ps;
         if (*pb) (*ps)+=1+*pl-cetnost[tr].c[*pb][p];
         *pl=cetnost[tr].c[*pb++][p]-1;
         cont|=*pl++;
        }
      }
    }
   ps=permstart[transPoli=transf[0]];
   xorFig=figXor[tr];
   permFig=cisloPerm[ps[0]][ps[1]][ps[2]][ps[3]];
  }
 else
  {transPoli=normtr;
   xorFig=pole[symPoradi[transPoli][trObsPoz[0]]]&0x0f;
   permFig=fig2PermBit[xorFig^pole[symPoradi[transPoli][trObsPoz[1]]]&0x0f];
  }
#ifdef DEBUG
 printf("permFig=%x,xorFig=%x,pozNum=%x,transPoli=%i,trObsazeni=%x\n",permFig,xorFig,pozNum,transPoli,trObsazeni);
#endif

#ifdef MOREDEBUG
 printf("pole: ");
 for(i=0;i<16;i++) printf("%02x ",pole[i]);
 printf("\n");
#endif

if (pocetPoli>1)
 hiNorm = pozNum<<2 | 
  fig2[permBit[permFig][(pole[symPoradi[transPoli][trObsPoz[1]]]^xorFig)&0x0f]];
else
 hiNorm = pozNum<<2;

loNorm=0; 
for (i=mez=pocetPoli>9?pocetPoli-8:2;i<pocetPoli;i++) 
 {loNorm<<=4; loNorm |= 
   permBit[permFig][(pole[symPoradi[transPoli][trObsPoz[i]]]^xorFig)&0x0f];}
for (i=2;i<mez;i++)
 {hiNorm<<=4; hiNorm |=
   permBit[permFig][(pole[symPoradi[transPoli][trObsPoz[i]]]^xorFig)&0x0f];}
if (mez==2)
 {posun=(10-pocetPoli)<<2;
   loNorm|=(hiNorm<<((32-posun)>>1))<<((32-posun)>>1);
   hiNorm>>=(posun>>1);hiNorm>>=(posun>>1);  // posun asi nemuze byt 32
 }
#ifdef DEBUG
  printf("%8x%08x norm>\n",hiNorm,loNorm);
#endif
}

void initHash ()
{int i;
  for (i=4;i<=MAXHASUJDO;i++)
   {hase[i].hashprime=0x4bc7d;
    hase[i].highfact=0xfa7;
    hase[i].idlen=((i+3)>>1)-((i>12)&1);}
  for (i=1;i<4;i++) hase[i].idlen=0;
  hase[1].hashprime=0x0C<<2; // velikost tabulky
  hase[2].hashprime=0x1C<<6;
  hase[3].hashprime=0x54<<10;
  for (i=4;i<=MAXHASUJDO;i++)
   hase[i].id = (char(*))malloc(hase[i].hashprime*hase[i].idlen);
  for (i=1;i<=MAXHASUJDO;i++)
   hase[i].vys = (char(*))calloc((3+hase[i].hashprime)>>2,1); // vynulovano
  for (i=1;i<=MAXHASUJDO;i++)
   initStat(&hase[i].s);
  hase[0]=hase[1]; // spolecna hash pro 1 a dve figury.
#ifdef DEBUGHASH
 for (i=1;i<=MAXHASUJDO;i++)
  printf("%01x %05x",hase[i].idlen,hase[i].hashprime);
 printf(" <- idlen\n");
#endif
}

unsigned hashedAddr;
hashtype *ht;

void addrHash ()
{unsigned hp;
 ht=&hase[tah];
 hashedAddr=hiNorm%(hp=ht->hashprime);
 hashedAddr*=ht->highfact;
 hashedAddr+=loNorm%hp;
 hashedAddr%=hp;
#ifdef DEBUGHASH
 if (!ht->idlen)
printf("norm=%08x%08x, hashedAddr=%05x, tah=%x\n",hiNorm,loNorm,hashedAddr,tah);
#endif
}

int testHash ()
{int vys,il,i,poz;
 osmbytu o;
 addrHash();
 ++(ht->s.hasovani);
 if (++(ht->s.hasovaninow)==hashMez) initStatNow(&ht->s);
 vys=ht->vys[hashedAddr>>2];
#ifdef DEBUGHASH
if (!ht->idlen)
 printf("test: vys=%02x ->",vys&0xff);
#endif
 vys>>=((hashedAddr&3)<<1);
 vys&=3;
 orivys[tah][poz=tahyp[tah]]=vys;
 normHash[tah][poz][0]=loNorm;
 normHash[tah][poz][1]=hiNorm;
#ifdef DEBUGHASH
if (!ht->idlen)
 printf("vys=%02x\n",vys&0xff);
#endif
 if (!vys) return hashvys[tah][poz]=0; // vysledek Nevim=0 mohu vratit ihned,
                     //  ostatni musim jeste zkontrolovat
 if (il=ht->idlen)    // je treba porovnat id
  {o.u[0]=o.u[1]=0;
   memcpy(&o,&ht->id[hashedAddr*il],il);
#ifdef DEBUGHASH
if (!ht->idlen)
 printf("test: o.u[0]=%08x,o.u[1]=%08x\n",o.u[0],o.u[1]);
#endif 
   // pozor big endian!!!
   if (o.u[0]!=loNorm || o.u[1]!=hiNorm)
    return hashvys[tah][poz]=0;       // id nesouhlasi
  }
#ifdef DEBUGHASH
if (!ht->idlen)
 printf("trefa!\n");
#endif
  ++(ht->s.trefy);
  ++(ht->s.trefynow);
  return hashvys[tah][poz]=vys;     // pokud id souhlasi
}

void pisHash(int vys) 
{char mask,shift, *vysP;int il;
 union osmbytu o;
 addrHash();
#ifdef DEBUGHASH
char v=vys;
if (!ht->idlen)
 printf("pis: vys=%02x ->",vys&0xff);
#endif
 vys<<=(shift=(hashedAddr&3)<<1);
 mask=3<<shift;
#ifdef DEBUGHASH
if (!ht->idlen)
 printf("vys=%02x mask=%02x tahyp[%x]=%x\n",vys&0xff,mask&0xff,tah,tahyp[tah]);
#endif
 vysP=&ht->vys[hashedAddr>>2];
 if (*vysP&mask) (ht->s.prepisy)++;
 else (ht->s.zapisy)++;
#ifdef DEBUGHASH
if (!ht->idlen)
 {printf("*vysP=%02x ->",*vysP&0xff);
 }
#endif
 *vysP&=~mask;
 *vysP|=vys;
#ifdef DEBUGHASH
if (!ht->idlen)
 printf("*vysP=%02x\n",*vysP&0xff);
#endif
 if (!(il=ht->idlen)) return; // adresa jednoznacne identifikuje vysledek
 o.u[0]=loNorm;o.u[1]=hiNorm;
#ifdef DEBUGHASH
if (!ht->idlen)
 printf("pis: o.u[0]=%08x, o.u[1]=%08x\n",o.u[0],o.u[1]);
#endif
 memcpy(&ht->id[hashedAddr*il],&o,il);
#ifdef DEBUGHASH
 if (v!=testHash())
  printf("!!Chyba\n");
#endif
}

int hasuj ( unsigned *lo=0, unsigned *hi=0 )
	// otestuje, zda je aktualni pozice (pole) jiz spocitana v cache
	// vrati vysledkove bity (Nevim az VyhralDruhy)
{unsigned adr;int vys;
#ifdef DEBUG
 printf(">hasuj\n");
#endif
 // if (tah>=14) return Nevim;  pro tah>=14 neni hasuj volano
 normalizuj(); // spocita hiNorm,loNorm   unsigned.

 return testHash();
}

//------------------------------------------------------------------------
//	vyhodnocovani - od nejjednodussich rutin po nejslozitejsi:

int vyber1 (int staci);
int vyber2 (int staci);


int poloz0 ( int kamen )
// vrati vysledek testu pri polozeni jedine figurky
// (vyhodnocuji pouze pozice).
// Mozne vysledky: Nevim, VyhralPrvni
{ int i;
  int sloupec;
  int *pradek, *psloupec;
  int *pol = pole;                    // ukazatel na pozici pole[i]

  int vysledek = Nevim;
#ifdef DEBUG
 printf(">p0 %x <- firstPole\n",firstPole);
  for (i=0;i<0x10;i++) printf("%x ",poleNext[i]);
  printf("<- poleNext\n");
  for (i=firstPole; i<0x10; i=poleNext[i]) printf("%x ",i);
  printf("<- seznam pole\n");
#endif 


  for ( i = firstPole; i<0x10 ; i=poleNext[i] )   // zkusim dalsi pole
   {*(pol=&pole[i]) = kamen;         //  Polozeni(kamen,i);
    sloupec = i & 3;
    pradek = pol - sloupec;
    psloupec = pole + sloupec;
#ifdef MOREDEBUG
 printf("%d *p0 %x\n",tah,i);
#endif
    if ( (pradek[0] & pradek[1] & pradek[2] & pradek[3]) ||       // radek
      (psloupec[0] & psloupec[4] & psloupec[8] & psloupec[12]) ||  // sloupec
      (pole[0] & pole[5] & pole[10] & pole[15]) ||      // hlavni diagonala
      (pole[3] & pole[6] & pole[9] & pole[12]) )       // vedlejsi diagonala
     {quart[tah]++;
      *pol = 0;      //  Zdvizeni(i);
#ifdef DEBUG
 printf("p0>\n");
#endif
      return VyhralPrvni;
     }
    *pol=0;       //  Zdvizeni(i);
   }
#ifdef DEBUG
 printf("p0>\n");
#endif
  return vysledek;
}

int poloz1 ( int kamen,int staci )
// vrati vysledek testu pri polozeni jedine figurky
// (vyhodnocuji pozice a divam se do hase, nevolam rekurzi).
// Mozne vysledky: Nevim, VyhralPrvni, Remiza, VyhralDruhy
{ int i,vys;

#ifdef DEBUG
 printf(">p1\n");
#endif

  if ( poloz0( kamen ) == VyhralPrvni )
   return VyhralPrvni;

  if (tah>=hasujDo)  // tah se o 1 zvetsi
   {if (tah==14) return Remiza;
    else 
     {minvys[tah+1]=VyhralDruhy;
      return Nevim;
     }
   }

#ifdef DEBUG
  printf(">p1 %x <- firstPole\n",firstPole);
  for (i=0;i<0x10;i++) printf("%x ",poleNext[i]);
  printf("<- poleNext\n");
  for (i=firstPole; i<0x10; i=poleNext[i]) printf("%x ",i);
  printf("<- seznam pole\n");
#endif

  Volba(kamen);
  minvys[tah]=vyslf[tah]=VyhralDruhy;
  for ( i = firstPole; i < 0x10; i=poleNext[i] )   // zkusim dalsi pole
   {Polozeni(kamen,i);
       // vzhledem k vysledku poloz0() neni jiz potreba testovat quartu
       // kouknu se proto do hase
#ifdef MOREDEBUG
 printf("%d *p1 %x, %x\n",tah,i,staci);
#endif
      vys = hasuj();
#ifdef MOREDEBUG
 printf("%d #p1 %x %d, %x\n",tah,i,vys,staci);
#endif
      Zdvizeni(i);
      if ( vys && vys <= staci )
       {
#ifdef DEBUG
printf("p1>\n");
#endif
        Odvoleni();
        return vys;
       }
      if (vys && vys<minvys[tah]) minvys[tah]=vys;
      if ( vys < vyslf[tah] )
      {vyslf[tah] = vys;
#ifdef MOREDEBUG
       if (vys) 
        {printf("vysl:%d\n",vys);
         tiskniTahy();
        }
#endif
      }
    }
#ifdef DEBUG
printf("p1>\n");
#endif
  Odvoleni();
  return vyslf[tah+1];
}

int poloz2 ( int *kamen, int staci )
// vrati uplny vysledek pri polozeni jedine figurky
// (vyhodnocuji pozice, divam se do cache, a volam rekurzi).
// Mozne vysledky: VyhralPrvni, Remiza, VyhralDruhy
{ int *poz,i,ph,found;
  int vys;
  unsigned hi,lo;

#ifdef DEBUG
 printf(">p2\n");
#endif

  if ( vys=poloz1(*kamen,staci ) )
    return vys;
//  je-li tah==14 (pokladame posledni kamen, je $vys\in\{VyhralPrvni,Remiza\}$)
#ifdef DEBUG
 printf(">p2 %x <- firstPole\n",firstPole);
  for (i=0;i<0x10;i++) printf("%x ",poleNext[i]);
  printf("<- poleNext\n");
  for (i=firstPole; i<0x10; i=poleNext[i]) printf("%x ",i);
  printf("<- seznam pole\n");
#endif
  DFSVolba(kamen);
  vyslf[tah] = minvys[tah];
  if (tah<=preHasujDo)
   {for ( i = firstPole; i < 0x10; i=poleNext[i] )   // zkusim dalsi pole
     if (!hashvys[tah][i]) // bude potreba pozici propocitat
      {ph=(loNorm=normHash[tah][i][0])%257;
       ph+=(hiNorm=normHash[tah][i][1])%257; //preHash adresa
       found=0;
       while (!found)
        if (preHashPoz[ph]==0x10) // volno
         {preHashNorm[ph][0]=loNorm;preHashNorm[ph][1]=hiNorm;
          found=1;
         }
        else if (preHashNorm[ph][0]==loNorm&&preHashNorm[ph][1]==hiNorm)
         {hashvys[tah][preHashPoz[ph]]=VyhralDruhy; 
           // zabrani rekurzi a neovlivni vysledek
          found=1;
         }
        else ph=(ph+1)%257;
       preHashPoz[toPreHash[i]=ph]=i;
      }
    for ( i = firstPole; i < 0x10; i=poleNext[i] )   // zkusim dalsi pole
     if (!hashvys[tah][i])
      {preHashPoz[toPreHash[i]]=0x10; // vyprazdnim preHash
      }
   }
  for ( poz=&firstPole; *poz < 0x10; poz=&poleNext[*poz] )
   {if (!hashvys[tah][*poz]) // vysledek nebyl v hashi
     {DFSPolozeni(poz); // zkusim dalsi pole a vynecham jej ze seznamu
       // muze se stat, ze mezitim byla spravna pozice zahashovana,
       // to je vsak velmi ridky jev a navic je potom velmi pravdepodobne
       // rychle nalezeno reseni z hase o tah nebo (u vyhry o dva) pozdeji 
       // take muze byt mezitim zmeneno orivys[], 
       // to ale pouze nepatrne pozmeni pravdepodobnosti pro reseni konfliktu,
       // prehozenim poradi policek bychom dosahli obdobneho vysledku 
       // vse je tedy OK
      vys = vyber2(Doplnek-vyslf[tah]); // spusti vyber1()
      DFSZdvizeni(poz);
      if (tah<=hasujDo)
       if (random()<prob[orivys[tah][*poz]][vys])
        {loNorm=normHash[tah][*poz][0];
         hiNorm=normHash[tah][*poz][1];
         pisHash(vys);
        }
      if ( vys <= staci )
       {DFSOdvoleni(kamen);
#ifdef DEBUG
 printf("p2>\n");
#endif
        return vys;}
      if ( vys < vyslf[tah] )
       {vyslf[tah] = vys;   // lepsi tah
#ifdef MOREDEBUG
        if (vys)
         {printf("vysl:%d\n",vys);
          tiskniTahy();
         }
#endif
       }
     }
   }
  DFSOdvoleni(kamen);
#ifdef DEBUG
 printf("p2>\n");
#endif
  return vyslf[tah+1];
}


int vyber1 (int staci)
{int fig;
 int vys;
 int kamen;
 
#ifdef DEBUG
 printf(">v1\n");
#endif
 // if ( tah==15 ) return Remiza; poloz2 konci bez volani rekurze pokud tah==14.

#ifdef DEBUG
 int i;
 printf(">v1 %x <- firstFig\n",firstFig);
  for (i=0;i<0x10;i++) printf("%x ",figNext[i]);
  printf("<- figNext\n");
  for (i=firstFig;i<0x10;i=figNext[i]) printf("%x ",i);
  printf("<- seznam figur\n");
#endif

 vyslp[tah] = VyhralDruhy;
 for ( fig = firstFig; fig < 0x10 ; fig=figNext[fig] )
  {kamen = (fig | ((~fig) << 4))&0xff;
#ifdef MOREDEBUG
 printf("%d *v1 %02x, %x\n",tah,kamen,staci);
#endif
    vys = poloz1(kamen,vyslp[tah]?Doplnek-vyslp[tah]:VyhralDruhy-staci);
#ifdef MOREDEBUG
 printf("%d #v1 %02x %d, %x\n",tah,kamen,vys,staci);
#endif
    vys ^= (vys<<1) & MaskaVysledku;  // negace vysledku
    if ( vys && vys <= staci )
      return vys;
    if ( vys < vyslp[tah] )
     {vyslp[tah] = vys;
#ifdef MOREDEBUG
if (vys) 
 {printf("vysl:%d\n",vys);
  tiskniTahy();
 }
#endif
     }
   }
#ifdef DEBUG
 printf("v1>");
#endif
  return vyslp[tah];
}

int vyber2 (int staci)
{int *fig;
 int vys;

#ifdef DEBUG
 printf(">v2\n");
#endif

if ( vys = vyber1(staci) )
  return vys;

#ifdef DEBUG
 int i;
 printf(">v1 %x <- firstFig\n",firstFig);
  for (i=0;i<0x10;i++) printf("%x ",figNext[i]);
  printf("<- figNext\n");
  for(i=firstFig;i<0x10;i=figNext[i]) printf("%x ",i);
  printf("<- seznam figur\n");
#endif

 vyslp[tah] = VyhralDruhy;
 for ( fig=&firstFig ; *fig < 0x10 ; fig=&figNext[*fig] )
  {vys = Doplnek - poloz2(fig,Doplnek-vyslp[tah]);     // vysledek neni Nevim!
#ifdef MOREDEBUG
 printf("%d #v2 %02x %d, %x\n",tah,*fig,vys,staci);
#endif
    if ( vys <= staci)
      return vys;
    if ( vys < vyslp[tah] )
     {vyslp[tah] = vys;
#ifdef MOREDEBUG
if (vys) 
 {printf("vysl:%d\n",vys);
  tiskniTahy();
 }
#endif
     }
   }
#ifdef DEBUG
 printf("v2>\n");
#endif
 return vyslp[tah];
}

int hra ()
{ int vys;

#ifdef DEBUG
 printf(">h\n");
#endif
  vyslf[0]=VyhralDruhy;
  firstMove(0);
  vys = vyber2(Doplnek-vyslf[0]);
  if ( vys < vyslf[0] ) vyslf[0]=vys;
  if ( vyslf[0] == VyhralPrvni ) return VyhralPrvni;
  firstMove(1);
  vys = vyber2(Doplnek-vyslf[0]);
  if ( vys < vyslf[0] ) vyslf[0]=vys;
  return vyslf[0];
}

void tiskni(int i)
{tiskniTahy();
 signal(SIGUSR1,tiskni);
}

void ulozStav()
{static int parita;int i;FILE *fsave;unsigned s;
 if (parita)
  fsave=fopen("i.sav0","w");
 else
  fsave=fopen("i.sav1","w");
 parita=!parita;
 time(&currTime);
 s=currTime-startTime+addTime;
 fprintf(fsave,"%u celkovy cas\n",s);
 fprintf(fsave,"%d pultah\n",pultah);
 for(i=0; (i<<1)<pultah;i++)
  fprintf(fsave,"%x ",tahyp[i]);
 fprintf(fsave," tahyp\n");
 for(i=0;(i<<1)<=pultah;i++ )
  fprintf(fsave,"%x ",tahyf[i]);
 fprintf(fsave," tahyf\n");
 for(i=0; (i<<1)<pultah;i++)
  fprintf(fsave,"%x ",vyslp[i]);
 fprintf(fsave," vyslp\n");
 for(i=0;(i<<1)<=pultah;i++ )
  fprintf(fsave,"%x ",vyslf[i]);
 fprintf(fsave," vyslf\n");
 for(i=1;i<=MAXHASUJDO;i++)
  {fwrite(hase[i].vys,1,(3+hase[i].hashprime)>>2,fsave);
   fprintf(fsave,"\n ^vys[%i]\n",i);
   fwrite(hase[i].id,hase[i].idlen,hase[i].hashprime,fsave);
   fprintf(fsave,"\n ^id[%i]\n",i);
  }
 fclose(fsave);
}

void loadStav()
{int i,j;FILE *fload;unsigned s;
 // novejsi "i.sav1"/"i.sav2"
 fload=fopen("i.sav","r");
 if (!fload) return;
 fscanf(fload,"%u celkovy cas\n",&addTime);
 fscanf(fload,"%d pultah\n",&pultah);
 for(i=0; (i<<1)<pultah;i++)
  fscanf(fload,"%x ",&tahyp[i]);
 fscanf(fload," tahyp\n");
 for(i=0;(i<<1)<=pultah;i++ )
  fscanf(fload,"%x ",&tahyf[i]);
 fscanf(fload," tahyf\n");
 for(i=0; (i<<1)<pultah;i++)
  fscanf(fload,"%x ",&vyslp[i]);
 fscanf(fload," vyslp\n");
 for(i=0;(i<<1)<=pultah;i++ )
  fscanf(fload,"%x ",&vyslf[i]);
 fscanf(fload," vyslf\n");
 for(i=1;i<=MAXHASUJDO;i++)
  {fread(hase[i].vys,1,(3+hase[i].hashprime)>>2,fload);
   fscanf(fload,"\n ^vys[%i]\n",&j);
   if (i!=j) {printf("problemy se ctenim ^vys[%i]\n",i);}
   fread(hase[i].id,hase[i].idlen,hase[i].hashprime,fload);
   fscanf(fload,"\n ^id[%i]\n",&j);
   if (i!=j) {printf("problemy se ctenim ^id[%i]\n",i);}
  }
 fclose(fload);
}

void uloz(int i)
{ulozStav();
 signal(SIGUSR2,uloz);
}

void writepid()
{FILE *fpid;
#ifdef DEBUGHASH
// return;
#endif
#ifdef MOREDEBUG
 return;
#endif
#ifdef DEBUG
 return;
#endif
  fpid=fopen("i.pid","w");
  fprintf(fpid,"%d pid\n start %s",getpid(),ctime(&startTime));
  fclose(fpid);
}

void readArgs(int cnt,char **args)
{if (cnt<2) return;
 sscanf(args[1],"%i",&hasujDo);
 if (hasujDo>MAXHASUJDO) printf("hasujDo snizeno na %i\n",hasujDo=MAXHASUJDO);
 if (cnt<3) return;
 sscanf(args[2],"%i",&normDo);
 if (cnt<4) return;
 sscanf(args[3],"%i",&preHasujDo);
}

void main (int cnt,char **args)
{       time(&startTime);
        initCisloPerm();
        initPermBit();
        initSymetrie();
        initNormTransf();
        initFig2();
        initFig2PermBit();
        initQuart();
        initHash();
        initProb();
        initVys();
        initPreHash();
        readArgs(cnt,args);
        loadStav();
        signal(SIGUSR1,tiskni);
        signal(SIGUSR2,uloz);
        printf("Start: %s\n",4+ctime(&startTime));
        printf("Stat: kill -SIGUSR1 %u\n",getpid());
        printf("Save: kill -SIGUSR2 %u\n",getpid());
        writepid();
        printf("Vysledek: %d\n",2-hra());
        tiskniTahy();
        ulozStav();
}
